package de.ozgcloud.eingang.xta;

import static org.mockito.Mockito.*;

import java.util.stream.Stream;

import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Nested;
import org.junit.jupiter.api.Test;
import org.mockito.InjectMocks;
import org.mockito.Mock;

import de.ozgcloud.eingang.common.formdata.FormData;
import de.ozgcloud.eingang.semantik.SemantikAdapter;

class XtaRunnerTest {

	@InjectMocks
	private XtaRunner scheduler;

	@Mock
	private XtaService service;
	@Mock
	private SemantikAdapter semantikAdapter;

	@Nested
	class TestRunGetXtaMessages {

		public static final FormData MESSAGE = FormDataTestFactory.create();

		@BeforeEach
		void init() {
			when(service.getMessages()).thenReturn(Stream.of(MESSAGE));
		}

		@Test
		void shouldCallXtaServiceGetNextMessages() {
			scheduler.runGetXtaMessages();

			verify(service).getMessages();
		}

		@Test
		void shouldHandOverFormDataToSemantikAdapter() {
			scheduler.runGetXtaMessages();

			verify(semantikAdapter).processFormData(MESSAGE);
		}

		@Test
		void shouldAcknowledgeReceive() {
			scheduler.runGetXtaMessages();

			verify(service).acknowledgeReceive(XtaMessageTestFactory.MESSAGE_ID);
		}
	}
}
